package nova.monadic_sfx.util.controls
import com.jfoenix.{controls => jfoenixc}
import scalafx.scene.Node
import scalafx.scene.layout.StackPane
import scalafx.scene.paint.Paint

class JFXRippler(
    override val delegate: jfoenixc.JFXRippler = new jfoenixc.JFXRippler
) extends StackPane(delegate) {
  import JFXRippler._
  def control = delegate.getControl()
  def control_=(v: Node) = delegate.setControl(v)
  def enabled_=(v: Boolean) = delegate.setEnabled(v)
  def ripplerPos = delegate.getPosition()
  def ripplerPos_=(pos: RipplerPos) = delegate.setPosition(pos)
  def ripplerDisabled = delegate.ripplerDisabledProperty()
  def ripplerDisabled_=(v: Boolean) = delegate.setRipplerDisabled(v)
  def ripplerFill = delegate.ripplerFillProperty()
  def ripplerFill_=(v: Paint) = delegate.setRipplerFill(v)
  def ripplerRecenter = delegate.ripplerRecenterProperty()
  def ripplerRecenter_=(v: Boolean) = delegate.setRipplerRecenter(v)
  def ripplerRadius = delegate.ripplerRadiusProperty()
  def ripplerRadius_=(v: Int) = delegate.setRipplerRadius(v)
}

object JFXRippler {
  abstract class RipplerPos(val delegate: jfoenixc.JFXRippler.RipplerPos)
  case object Front extends RipplerPos(jfoenixc.JFXRippler.RipplerPos.FRONT)
  case object Back extends RipplerPos(jfoenixc.JFXRippler.RipplerPos.BACK)
  object RipplerPos {
    implicit def sfxRipplerPos2jfxRipplerPos(
        v: RipplerPos
    ): jfoenixc.JFXRippler.RipplerPos = v.delegate
  }
  implicit def sfxRippler2jfxRippler(v: JFXRippler): jfoenixc.JFXRippler =
    v.delegate
}
